<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: llg/writelog_pvode.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_ad11b878d2835527517911859427b54f.html">llg</a>
  </div>
</div>
<div class="contents">
<h1>writelog_pvode.c</h1><a href="writelog__pvode_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: writelog_pvode.c 2962 2010-02-04 19:50:44Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="llg_8h.html">llg.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;cvode/cvode.h&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="preprocessor">#if SUNDIALS_VERSION &gt;= 230</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span><span class="preprocessor">#include &quot;cvode/cvode_spgmr.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#else</span>
<a name="l00034"></a>00034 <span class="preprocessor"></span><span class="preprocessor">#error &quot;SUNDIALS versions lower/older than 2.3.0 are not supported&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00036"></a>00036 <span class="preprocessor"></span>
<a name="l00037"></a>00037 <span class="keyword">static</span> <span class="keywordtype">int</span>  doinit=1;
<a name="l00038"></a>00038 <span class="keyword">static</span> <span class="keywordtype">int</span>  fieldon=0;
<a name="l00039"></a>00039 <span class="keyword">static</span> FILE *logfile=NULL; 
<a name="l00041"></a><a class="code" href="writelog__pvode_8c.html#a3e2b0c2d1553ae99499b4d70f14bba10">00041</a> <span class="keywordtype">int</span> <a class="code" href="writelog__pvode_8c.html#a3e2b0c2d1553ae99499b4d70f14bba10">WriteLogPVodeInit</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00042"></a>00042 {
<a name="l00043"></a>00043   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00044"></a>00044 
<a name="l00045"></a>00045   <span class="keywordtype">int</span> rank,size;
<a name="l00046"></a>00046   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00047"></a>00047   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00048"></a>00048 
<a name="l00049"></a>00049   <span class="keywordflow">if</span> (rank) {
<a name="l00050"></a>00050     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00051"></a>00051   }
<a name="l00052"></a>00052 
<a name="l00053"></a>00053   <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#ae420f7fb3d60720f21c5852955b94eae">mode</a>!=0 &amp;&amp; gdata-&gt;<a class="code" href="structGridData.html#ae420f7fb3d60720f21c5852955b94eae">mode</a>!=2 &amp;&amp; gdata-&gt;<a class="code" href="structGridData.html#ae420f7fb3d60720f21c5852955b94eae">mode</a>!=3) {
<a name="l00054"></a>00054     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00055"></a>00055   }
<a name="l00056"></a>00056   fieldon=1;
<a name="l00057"></a>00057 
<a name="l00058"></a>00058   <span class="keywordtype">char</span> fmesh[256];
<a name="l00059"></a>00059   ierr = PetscSNPrintf(fmesh,255,<span class="stringliteral">&quot;%s%s&quot;</span>,gdata-&gt;<a class="code" href="structGridData.html#a2fba16fa768b0451df8fd12ed00a6c6b">simname</a>,<span class="stringliteral">&quot;.log_pvode&quot;</span>);CHKERRQ(ierr);
<a name="l00060"></a>00060   ierr = PetscFOpen(PETSC_COMM_WORLD,fmesh,<span class="stringliteral">&quot;a&quot;</span>,&amp;logfile);CHKERRQ(ierr);
<a name="l00061"></a>00061   <span class="keywordflow">if</span> (!logfile) {
<a name="l00062"></a>00062     SETERRQ1(PETSC_ERR_FILE_OPEN,<span class="stringliteral">&quot;Cannot open %s\n&quot;</span>,fmesh);
<a name="l00063"></a>00063   }
<a name="l00064"></a>00064   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Opening file %s\n&quot;</span>,fmesh);
<a name="l00065"></a>00065 
<a name="l00066"></a>00066   PetscGetDate(fmesh,255);
<a name="l00067"></a>00067   ierr = PetscFPrintf(PETSC_COMM_WORLD,
<a name="l00068"></a>00068     logfile,
<a name="l00069"></a>00069     <span class="stringliteral">&quot;#.date: %s\n&quot;</span>,
<a name="l00070"></a>00070     fmesh
<a name="l00071"></a>00071   );
<a name="l00072"></a>00072 
<a name="l00073"></a>00073   <span class="comment">/*      1   2   3   4   5   6   7   8   9  10 */</span>
<a name="l00074"></a>00074   ierr = PetscFPrintf(PETSC_COMM_WORLD,logfile,
<a name="l00075"></a>00075     <span class="stringliteral">&quot;#.%14s %7s %4s %4s %4s %4s %4s %4s %4s %4s\n&quot;</span>,
<a name="l00076"></a>00076     <span class="stringliteral">&quot;............1:&quot;</span>,
<a name="l00077"></a>00077     <span class="stringliteral">&quot; 2:&quot;</span>,
<a name="l00078"></a>00078     <span class="stringliteral">&quot; 3:&quot;</span>,
<a name="l00079"></a>00079     <span class="stringliteral">&quot; 4:&quot;</span>,
<a name="l00080"></a>00080     <span class="stringliteral">&quot; 5:&quot;</span>,
<a name="l00081"></a>00081     <span class="stringliteral">&quot; 6:&quot;</span>,
<a name="l00082"></a>00082     <span class="stringliteral">&quot; 7:&quot;</span>,
<a name="l00083"></a>00083     <span class="stringliteral">&quot; 8:&quot;</span>,
<a name="l00084"></a>00084     <span class="stringliteral">&quot; 9:&quot;</span>,
<a name="l00085"></a>00085     <span class="stringliteral">&quot;10:&quot;</span>
<a name="l00086"></a>00086   );CHKERRQ(ierr);
<a name="l00087"></a>00087   <span class="comment">/*      1   2   3   4   5   6   7   8   9  10 */</span>
<a name="l00088"></a>00088   ierr = PetscFPrintf(PETSC_COMM_WORLD,logfile,
<a name="l00089"></a>00089     <span class="stringliteral">&quot;#.%14s %7s %4s %4s %4s %4s %4s %4s %4s %4s\n&quot;</span>,
<a name="l00090"></a>00090     <span class="stringliteral">&quot;..........time&quot;</span>,
<a name="l00091"></a>00091     <span class="stringliteral">&quot;nstep&quot;</span>,
<a name="l00092"></a>00092     <span class="stringliteral">&quot;qu&quot;</span>,
<a name="l00093"></a>00093     <span class="stringliteral">&quot;nfe&quot;</span>,
<a name="l00094"></a>00094     <span class="stringliteral">&quot;nni&quot;</span>,
<a name="l00095"></a>00095     <span class="stringliteral">&quot;ncfn&quot;</span>,
<a name="l00096"></a>00096     <span class="stringliteral">&quot;nli&quot;</span>,
<a name="l00097"></a>00097     <span class="stringliteral">&quot;npe&quot;</span>,
<a name="l00098"></a>00098     <span class="stringliteral">&quot;nps&quot;</span>,
<a name="l00099"></a>00099     <span class="stringliteral">&quot;ncfl&quot;</span>
<a name="l00100"></a>00100   );CHKERRQ(ierr);
<a name="l00101"></a>00101   <span class="comment">/*      1   2   3   4   5   6   7   8   9  10 */</span>
<a name="l00102"></a>00102   ierr = PetscFPrintf(PETSC_COMM_WORLD,logfile,
<a name="l00103"></a>00103     <span class="stringliteral">&quot;#.%14s %7s %4s %4s %4s %4s %4s %4s %4s %4s\n&quot;</span>,
<a name="l00104"></a>00104     <span class="comment">/* &quot;time&quot;,      */</span> <span class="stringliteral">&quot;..........(ns)&quot;</span>,
<a name="l00105"></a>00105     <span class="comment">/* &quot;nstep&quot;,     */</span> <span class="stringliteral">&quot;-&quot;</span>,
<a name="l00106"></a>00106     <span class="comment">/* &quot;qu&quot;,        */</span> <span class="stringliteral">&quot;-&quot;</span>,
<a name="l00107"></a>00107     <span class="comment">/* &quot;nfe&quot;,       */</span> <span class="stringliteral">&quot;-&quot;</span>,
<a name="l00108"></a>00108     <span class="comment">/* &quot;nni&quot;,       */</span> <span class="stringliteral">&quot;-&quot;</span>,
<a name="l00109"></a>00109     <span class="comment">/* &quot;ncfn&quot;,      */</span> <span class="stringliteral">&quot;-&quot;</span>,
<a name="l00110"></a>00110     <span class="comment">/* &quot;nli&quot;,       */</span> <span class="stringliteral">&quot;-&quot;</span>,
<a name="l00111"></a>00111     <span class="comment">/* &quot;npe&quot;,       */</span> <span class="stringliteral">&quot;-&quot;</span>,
<a name="l00112"></a>00112     <span class="comment">/* &quot;nps&quot;,       */</span> <span class="stringliteral">&quot;-&quot;</span>,
<a name="l00113"></a>00113     <span class="comment">/* &quot;ncfl&quot;,      */</span> <span class="stringliteral">&quot;-&quot;</span>
<a name="l00114"></a>00114   );CHKERRQ(ierr);
<a name="l00115"></a>00115 
<a name="l00116"></a>00116   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00117"></a>00117 }
<a name="l00118"></a>00118 
<a name="l00119"></a>00119 
<a name="l00120"></a><a class="code" href="writelog__pvode_8c.html#afc3aa13e4e04c3b501cf220d4cc1e3ee">00120</a> <span class="keywordtype">int</span> <a class="code" href="writelog__pvode_8c.html#afc3aa13e4e04c3b501cf220d4cc1e3ee">WriteLogPVode</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00121"></a>00121 {
<a name="l00122"></a>00122   <span class="keyword">extern</span> <span class="keywordtype">void</span> *<a class="code" href="mytscreatepvode_8c.html#a809fb699daf418600ff788f3826954c9">cvode_mem</a>;
<a name="l00123"></a>00123 
<a name="l00124"></a>00124   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00125"></a>00125 
<a name="l00126"></a>00126   <span class="keywordflow">if</span> (doinit) {
<a name="l00127"></a>00127     ierr = <a class="code" href="writelog__pvode_8c.html#a3e2b0c2d1553ae99499b4d70f14bba10">WriteLogPVodeInit</a>(gdata);CHKERRQ(ierr);
<a name="l00128"></a>00128     doinit=0;
<a name="l00129"></a>00129   }
<a name="l00130"></a>00130   <span class="keywordflow">if</span> (!fieldon || cvode_mem==PETSC_NULL) {
<a name="l00131"></a>00131     <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(0);
<a name="l00132"></a>00132   }
<a name="l00133"></a>00133 
<a name="l00134"></a>00134   <span class="keywordtype">int</span> flag;
<a name="l00135"></a>00135   <span class="keyword">static</span> <span class="keywordtype">long</span> <span class="keywordtype">int</span> last_nfe,last_nni,last_ncfn,last_nli,last_npe,last_nps,last_ncfl,last_nstep;
<a name="l00136"></a>00136   <span class="keywordtype">long</span> <span class="keywordtype">int</span> nstep,nfe,nni,ncfn,nli,npe,nps,ncfl;
<a name="l00137"></a>00137   <span class="keywordtype">int</span> qu;
<a name="l00138"></a>00138 
<a name="l00139"></a>00139   flag=CVodeGetNumSteps(cvode_mem,&amp;nstep);
<a name="l00140"></a>00140 
<a name="l00141"></a>00141   <span class="comment">/* if PVODE hase been (re)started */</span>
<a name="l00142"></a>00142   <span class="keywordflow">if</span> (nstep==0 || nstep&lt;last_nstep) {
<a name="l00143"></a>00143     <span class="comment">/* reset counters */</span>
<a name="l00144"></a>00144     last_nfe=last_nni=last_ncfn=last_nli=last_npe=last_nps=last_ncfl=0;
<a name="l00145"></a>00145   }
<a name="l00146"></a>00146   <span class="keywordflow">if</span> (nstep==0) {
<a name="l00147"></a>00147     nfe=nni=ncfn=nli=npe=nps=ncfl=0;
<a name="l00148"></a>00148     qu=0;
<a name="l00149"></a>00149   }
<a name="l00150"></a>00150   <span class="keywordflow">else</span> {
<a name="l00151"></a>00151     flag=CVodeGetLastOrder(cvode_mem,&amp;qu);
<a name="l00152"></a>00152     flag=CVodeGetNumRhsEvals(cvode_mem,&amp;nfe);
<a name="l00153"></a>00153     flag=CVodeGetNumNonlinSolvIters(cvode_mem,&amp;nni);
<a name="l00154"></a>00154     flag=CVodeGetNumNonlinSolvConvFails(cvode_mem,&amp;ncfn);
<a name="l00155"></a>00155 <span class="preprocessor">#if SUNDIALS_VERSION &gt;= 230</span>
<a name="l00156"></a>00156 <span class="preprocessor"></span>    flag=CVSpilsGetNumLinIters(  cvode_mem,&amp;nli);
<a name="l00157"></a>00157     flag=CVSpilsGetNumPrecEvals( cvode_mem,&amp;npe);
<a name="l00158"></a>00158     flag=CVSpilsGetNumPrecSolves(cvode_mem,&amp;nps);
<a name="l00159"></a>00159     flag=CVSpilsGetNumConvFails( cvode_mem,&amp;ncfl);
<a name="l00160"></a>00160 <span class="preprocessor">#else</span>
<a name="l00161"></a>00161 <span class="preprocessor"></span><span class="preprocessor">#error &quot;SUNDIALS versions lower/older than 2.3.0 are not supported&quot;</span>
<a name="l00162"></a>00162 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00163"></a>00163 <span class="preprocessor"></span>  }
<a name="l00164"></a>00164 
<a name="l00165"></a>00165   <span class="comment">/*     1   2    3    4    5    6    7    8    9   10 */</span>
<a name="l00166"></a>00166   ierr = PetscFPrintf(PETSC_COMM_WORLD,logfile,
<a name="l00167"></a>00167     <span class="stringliteral">&quot;  %14e %7d %4d %4ld %4ld %4ld %4ld %4ld %4ld %4ld\n&quot;</span>,
<a name="l00168"></a>00168     <span class="comment">/* &quot; 1:time&quot;,      */</span> gdata-&gt;<a class="code" href="structGridData.html#a9eb9246406e97a2a4a8a9c471b11aa2a">time</a>*gdata-&gt;<a class="code" href="structGridData.html#ad7a22de0cb266e66e8dbcb1bb147bae8">tscale</a>*1e9,
<a name="l00169"></a>00169     <span class="comment">/* &quot; 2:nstep&quot;,     */</span> nstep,
<a name="l00170"></a>00170     <span class="comment">/* &quot; 3:qu&quot;,        */</span> qu,
<a name="l00171"></a>00171     <span class="comment">/* &quot; 4:nfe&quot;,       */</span> nfe- last_nfe,
<a name="l00172"></a>00172     <span class="comment">/* &quot; 5:nni&quot;,       */</span> nni- last_nni,
<a name="l00173"></a>00173     <span class="comment">/* &quot; 6:ncfn&quot;,      */</span> ncfn-last_ncfn,
<a name="l00174"></a>00174     <span class="comment">/* &quot; 7:nli&quot;,       */</span> nli- last_nli,
<a name="l00175"></a>00175     <span class="comment">/* &quot; 8:npe&quot;,       */</span> npe- last_npe,
<a name="l00176"></a>00176     <span class="comment">/* &quot; 9:nps&quot;,       */</span> nps- last_nps,
<a name="l00177"></a>00177     <span class="comment">/* &quot;10:ncfl&quot;,      */</span> ncfl-last_ncfl
<a name="l00178"></a>00178   );
<a name="l00179"></a>00179 
<a name="l00180"></a>00180   last_nfe=  nfe;
<a name="l00181"></a>00181   last_nni=  nni;
<a name="l00182"></a>00182   last_ncfn= ncfn;
<a name="l00183"></a>00183   last_nli=  nli;
<a name="l00184"></a>00184   last_npe=  npe;
<a name="l00185"></a>00185   last_nps=  nps;
<a name="l00186"></a>00186   last_ncfl= ncfl;
<a name="l00187"></a>00187   last_nstep= nstep;
<a name="l00188"></a>00188 
<a name="l00189"></a>00189   <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(0);
<a name="l00190"></a>00190 }
<a name="l00191"></a>00191 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

